package com.osgi.bundle;

import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleActivator;
import org.osgi.util.tracker.ServiceTracker;

import com.osgi.service.CurrencyImpl;

public class ExchangeActivator implements BundleActivator
{
    private ServiceTracker<Object, Object> tracker;

    public void start(BundleContext context) throws Exception
    {
        System.out.println("start bundle exchange");

        // создание и открытие трекера
        tracker = new ServiceTracker<Object, Object>(context, CurrencyImpl.class.getName(), null);
        tracker.open();
    
        ExchangeImpl list = new ExchangeImpl(tracker);        

        // вывод в консоль списка валют
        System.out.println("currencies list");
        for (String item : list.getCurrencies())
            System.out.println(item);
    }

    public void stop(BundleContext context) throws Exception
    {
        System.out.println("stop bundle exchange");
        tracker.close();
    }
}
